
#property copyright " 2005-2010 BJF Trading Group"
#property link      "http://www.iticsoftware.com"
#property show_inputs

#define major   3
#define minor   3

//-----------------------------------------------------------------------------

extern string ___tmp1_____________ = " --- Main settings ---";
extern string   ChannelID = "F5AC-11DB-BBA8";
extern int      Timer.msec = 1000;
extern bool     CheckConnection = true;


extern string ___tmp2_____________ = " --- Labels ---";
extern int      Timer.Corner = 1;
extern int      Timer.X = 20;
extern int      Timer.Y = 20;
extern string   Timer.FontName = "Arial Narrow";
extern int      Timer.FontSize = 24;
extern color    Timer.FontColor = Gold;

extern int      Error.Corner = 1;
extern int      Error.X = 20;
extern int      Error.Y = 60;
extern string   Error.FontName = "Arial Narrow";
extern int      Error.FontSize = 18;
extern color    Error.FontColor = Red;

extern int      Demo.Corner = 0;
extern int      Demo.X = 20;
extern int      Demo.Y = 30;
extern int      Demo.dY = 26;
extern string   Demo.FontName = "Arial Narrow";
extern int      Demo.FontSize = 20;
extern color    Demo.FontColor = Red;
extern color    Demo.BackColor = White;

extern int      About.Corner = 3;
extern int      About.X = 20;
extern int      About.Y = 15;
extern int      About.dY = 16;
extern string   About.FontName = "Verdana";
extern int      About.FontSize = 9;
extern color    About.FontColor = Silver;

//-----------------------------------------------------------------------------

#import "user32.dll"
  int GetParent(int hWnd);
#import

#import "mtfx_v30dm.dll"
  int _find_window(string class);

  int _init(int hTerminal, int hChart);
  int _deinit(int hTerminal, int hChart);
  int _marker_send(int hTerminal, int hChart);
  int _get_crc();
         
  void _image_clear();
  void _image_set(string channel_id, string login);
  
  void _image_append(
    int mode, 
    int digits, 
    int lot_prec, 
    int ticket, 
    int open_time, 
    int type, 
    double lots, 
    string symbol, 
    double open_price, 
    double sl, 
    double tp, 
    int close_time, 
    double close_price,
    datetime expiration,
    int magic, 
    string comment);
    
  void _image_send(int hTerminal);
#import

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

string prefix;

int init_cnt = 0;
int LastCRC = 0;
int LastTickCount = 0;
int hTerminal = 0;
int hChart = 0;
int marker_ret_code;

int Demo.Counter = 0;


void init()
{
  prefix = WindowExpertName() + "_";
    
  clear();
}

void deinit() 
{
  _deinit(hTerminal, hChart);
  
  clear();
  Comment("");
}

void start() 
{ 
  while (!IsStopped())
  {    
    string msg = TimeToStr(TimeLocal(), TIME_DATE|TIME_SECONDS);
    Timer.TextOut(msg);
    
    Demo.TextOut();
    About.TextOut();
    WindowRedraw();
      
    int res = main();
    if (res > 0) break;
    
    Sleep(Timer.msec);
  }
}

int main()
{ 
  Error.TextOut("");
  
  //-----
  
  hTerminal = TerminalHandle();
  if (hTerminal == 0)
  {
    Print("Terminal handle is NULL !!!");
    return (0);
  }
  
  hChart = WindowHandle(Symbol(), 0);
  if (hChart == 0)
  {
    Print("Chart handle is NULL !!!");
    return (0);
  }
  
  if (init_cnt == 0)
  {
    _init(hTerminal, hChart);
    init_cnt++;
  }  
  
  //-----

  int ret = _find_window(ChannelID);
  if (ret == 0) 
  {
    Error.TextOut("Cannot find MultiTrade-Fx window !!!");
    WindowRedraw();
    
    LastCRC = 0;
    return (0);
  }

  if (CheckConnection && !IsConnected()) 
  {
    Error.TextOut("No connection !!!");
    WindowRedraw();
    
    LastCRC = 0;
    return (0);
  }
  
  if (AccountNumber() <= 0)
  {
    Error.TextOut("Account not ready !!!");
    WindowRedraw();
    
    LastCRC = 0;
    return (0);
  }
    
  if (OrdersHistoryTotal() <= 0)
  {
    Error.TextOut("History not loaded !!!");
    WindowRedraw();
    
    LastCRC = 0;
    return (0);
  }


  if (MathAbs(GetTickCount() - LastTickCount) >= 10*1000)
  {
    marker_ret_code = _marker_send(hTerminal, hChart);
    LastTickCount = GetTickCount();
  }

  if (marker_ret_code == 1)
  {
    //Error.TextOut("Second instance of the script is not allowed.");
    //WindowRedraw();

    Alert("Second instance of the script is not allowed.");
    return (1);
  }
  
  //-----

  _image_clear();
  
  string login = AccountNumber();
  _image_set(ChannelID, login);
  
  int cnt = OrdersTotal();
  for (int i=0; i < cnt; i++) 
  {
    if (!OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) continue;
    
    int type = OrderType();
    switch (type)
    {
      case OP_BUY: case OP_SELLSTOP:
        break;
      
      default:
        continue;
    }
    
    if (MathAbs(OrderLots() - 1.0) >= 0.0001) continue;
    
    _image_append(
      MODE_TRADES, 
      MarketInfo(OrderSymbol(), MODE_DIGITS), 
      2, 
      OrderTicket(),
      OrderOpenTime(), 
      OrderType(), 
      OrderLots(), 
      OrderSymbol(),
      OrderOpenPrice(), 
      OrderStopLoss(), 
      OrderTakeProfit(), 
      OrderCloseTime(), 
      OrderClosePrice(),
      OrderExpiration(),
      OrderMagicNumber(), 
      OrderComment());
  }
  
  cnt = OrdersHistoryTotal();
  for (i=0; i < cnt; i++) 
  {
    if (!OrderSelect(i, SELECT_BY_POS, MODE_HISTORY)) continue;

    type = OrderType();
    switch (type)
    {
      case OP_BUY: case OP_SELLSTOP:
        break;
      
      default:
        continue;
    }

    if (MathAbs(OrderLots() - 1.0) >= 0.0001) continue;
        
    _image_append(
      MODE_HISTORY,
      MarketInfo(OrderSymbol(), MODE_DIGITS), 
      2, 
      OrderTicket(),
      OrderOpenTime(), 
      OrderType(), 
      OrderLots(), 
      OrderSymbol(),
      OrderOpenPrice(), 
      OrderStopLoss(), 
      OrderTakeProfit(), 
      OrderCloseTime(), 
      OrderClosePrice(),
      OrderExpiration(),
      OrderMagicNumber(), 
      OrderComment());
  }
  
  int crc = _get_crc();
//Comment(crc);
  if (crc != LastCRC)
  {
    LastCRC = crc;   
    _image_send(hTerminal);
  }
      
  return (0);
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

int TerminalHandle() 
{
  int hWnd = WindowHandle(Symbol(), Period());
  int hParent = 0;
  
  while (!IsStopped()) 
  {
    hWnd = GetParent(hWnd);
    if (hWnd == 0) break;
    hParent = hWnd;
  }
  
  return (hParent);
}

void clear()
{
  int total = ObjectsTotal();  
  for (int i=total-1; i >= 0; i--) 
  {
    string name = ObjectName(i);
    if (StringFind(name, prefix) == 0) ObjectDelete(name);
  }
  
  WindowRedraw();
  Comment("");
}

void Timer.TextOut(string txt)
{
  string obj_name = prefix + "timer";
  if (ObjectFind(obj_name) == -1) {
    ObjectCreate(obj_name, OBJ_LABEL, 0, 0, 0);
  }

  ObjectSet(obj_name, OBJPROP_XDISTANCE, Timer.X);
  ObjectSet(obj_name, OBJPROP_YDISTANCE, Timer.Y);
  ObjectSet(obj_name, OBJPROP_CORNER, Timer.Corner);

  ObjectSetText(obj_name, txt, Timer.FontSize, Timer.FontName, Timer.FontColor);
}

void Error.TextOut(string txt)
{
  string obj_name = prefix + "err";
  if (ObjectFind(obj_name) == -1) {
    ObjectCreate(obj_name, OBJ_LABEL, 0, 0, 0);
  }

  ObjectSet(obj_name, OBJPROP_XDISTANCE, Error.X);
  ObjectSet(obj_name, OBJPROP_YDISTANCE, Error.Y);
  ObjectSet(obj_name, OBJPROP_CORNER, Error.Corner);

  ObjectSetText(obj_name, txt, Error.FontSize, Error.FontName, Error.FontColor);
}

void Demo.TextOut()
{
  string obj_name, txt;
  
  txt = CharToStr(108);

  for (int i=0; i < 430; i += 5)
  {
    for (int j=-15; j < 65; j += 5)
    {
      obj_name = prefix + "demo_bg_" + i + " _" + j;
      if (ObjectFind(obj_name) == -1) 
      {
        ObjectCreate(obj_name, OBJ_LABEL, 0, 0, 0);
      }

      ObjectSet(obj_name, OBJPROP_XDISTANCE, Demo.X + i - 20);
      ObjectSet(obj_name, OBJPROP_YDISTANCE, Demo.Y + j);
      ObjectSet(obj_name, OBJPROP_CORNER, Demo.Corner);
      ObjectSet(obj_name, OBJPROP_BACK, true);

      ObjectSetText(obj_name, txt, 30, "Wingdings", Demo.BackColor);
    }
  }

  //-----
    
  obj_name = prefix + "demo1";
  if (ObjectFind(obj_name) == -1) {
    ObjectCreate(obj_name, OBJ_LABEL, 0, 0, 0);
  }

  ObjectSet(obj_name, OBJPROP_XDISTANCE, Demo.X);
  ObjectSet(obj_name, OBJPROP_YDISTANCE, Demo.Y);
  ObjectSet(obj_name, OBJPROP_CORNER, Demo.Corner);

  txt = "     DEMO version  ";
  for (i = 0; i < Demo.Counter; i++)
  {
    txt = txt + ".";
  }
  
  Demo.Counter += 1;
  if (Demo.Counter > 3) Demo.Counter = 0;
  
  ObjectSetText(obj_name, txt, Demo.FontSize, Demo.FontName, Demo.FontColor);
  
  //-----

  txt = "1) Copied BUY and SELLSTOP orders only";
  
  obj_name = prefix + "demo2";
  if (ObjectFind(obj_name) == -1) {
    ObjectCreate(obj_name, OBJ_LABEL, 0, 0, 0);
  }

  ObjectSet(obj_name, OBJPROP_XDISTANCE, Demo.X);
  ObjectSet(obj_name, OBJPROP_YDISTANCE, Demo.Y+Demo.dY);
  ObjectSet(obj_name, OBJPROP_CORNER, Demo.Corner);

  ObjectSetText(obj_name, txt, Demo.FontSize, Demo.FontName, Demo.FontColor);
  
  //-----
  
  txt = "2) Copied orders with 1.0 lots volume only"; 
  
  obj_name = prefix + "demo3";
  if (ObjectFind(obj_name) == -1) {
    ObjectCreate(obj_name, OBJ_LABEL, 0, 0, 0);
  }

  ObjectSet(obj_name, OBJPROP_XDISTANCE, Demo.X);
  ObjectSet(obj_name, OBJPROP_YDISTANCE, Demo.Y+2*Demo.dY);
  ObjectSet(obj_name, OBJPROP_CORNER, Demo.Corner);

  ObjectSetText(obj_name, txt, Demo.FontSize, Demo.FontName, Demo.FontColor);
  
}

void About.TextOut()
{
  string txt;
  string spr = "--------------------------------------";
  
  string obj_name = prefix + "about1";
  if (ObjectFind(obj_name) == -1) {
    ObjectCreate(obj_name, OBJ_LABEL, 0, 0, 0);
  }

  ObjectSet(obj_name, OBJPROP_XDISTANCE, About.X);
  ObjectSet(obj_name, OBJPROP_YDISTANCE, About.Y);
  ObjectSet(obj_name, OBJPROP_CORNER, About.Corner);

  txt = "http://www.iticsoftware.com";
  ObjectSetText(obj_name, txt, About.FontSize, About.FontName, About.FontColor);

  //-----
  
  obj_name = prefix + "about2";
  if (ObjectFind(obj_name) == -1) {
    ObjectCreate(obj_name, OBJ_LABEL, 0, 0, 0);
  }

  ObjectSet(obj_name, OBJPROP_XDISTANCE, About.X);
  ObjectSet(obj_name, OBJPROP_YDISTANCE, About.Y+About.dY);
  ObjectSet(obj_name, OBJPROP_CORNER, About.Corner);

  txt = " 2005-2009 BJF Trading Group";
  ObjectSetText(obj_name, txt, About.FontSize, About.FontName, About.FontColor);


  obj_name = prefix + "about2b";
  if (ObjectFind(obj_name) == -1) {
    ObjectCreate(obj_name, OBJ_LABEL, 0, 0, 0);
  }

  ObjectSet(obj_name, OBJPROP_XDISTANCE, About.X);
  ObjectSet(obj_name, OBJPROP_YDISTANCE, About.Y+2*About.dY);
  ObjectSet(obj_name, OBJPROP_CORNER, About.Corner);

  txt = spr;
  ObjectSetText(obj_name, txt, About.FontSize, About.FontName, Red);

  //-----
  
  obj_name = prefix + "about3";
  if (ObjectFind(obj_name) == -1) {
    ObjectCreate(obj_name, OBJ_LABEL, 0, 0, 0);
  }

  ObjectSet(obj_name, OBJPROP_XDISTANCE, About.X);
  ObjectSet(obj_name, OBJPROP_YDISTANCE, About.Y+3*About.dY);
  ObjectSet(obj_name, OBJPROP_CORNER, About.Corner);

  txt = "Channel ID: " + ChannelID;
  ObjectSetText(obj_name, txt, About.FontSize, About.FontName, About.FontColor);

  //-----
    
  obj_name = prefix + "about4";
  if (ObjectFind(obj_name) == -1) {
    ObjectCreate(obj_name, OBJ_LABEL, 0, 0, 0);
  }

  ObjectSet(obj_name, OBJPROP_XDISTANCE, About.X);
  ObjectSet(obj_name, OBJPROP_YDISTANCE, About.Y+4*About.dY);
  ObjectSet(obj_name, OBJPROP_CORNER, About.Corner);

  txt = "Type: CopyTool master script";
  ObjectSetText(obj_name, txt, About.FontSize, About.FontName, About.FontColor);

  //-----
    
  obj_name = prefix + "about5";
  if (ObjectFind(obj_name) == -1) {
    ObjectCreate(obj_name, OBJ_LABEL, 0, 0, 0);
  }

  ObjectSet(obj_name, OBJPROP_XDISTANCE, About.X);
  ObjectSet(obj_name, OBJPROP_YDISTANCE, About.Y+5*About.dY);
  ObjectSet(obj_name, OBJPROP_CORNER, About.Corner);

  txt = "File: " + WindowExpertName() + ".ex4";
  ObjectSetText(obj_name, txt, About.FontSize, About.FontName, About.FontColor);
}